package gregapi.tileentity.inventories;

import static gregapi.data.CS.F;
import static gregapi.data.CS.RES_PATH_GUI;
import static gregapi.data.CS.T;
import static gregapi.data.CS.ZL_INTEGER;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetPlayerRelativeBlockHardness;
import gregapi.block.multitileentity.MultiTileEntityContainer;
import gregapi.gui.ContainerClient;
import gregapi.gui.ContainerCommon;
import gregapi.gui.Slot_Normal;
import gregapi.tileentity.base.TileEntityBase09FacingSingle;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
public abstract class MultiTileEntitySafe extends TileEntityBase09FacingSingle implements ISidedInventory, IMTE_GetPlayerRelativeBlockHardness {
    @Override
	public boolean onBlockActivated3(EntityPlayer aPlayer, byte aSide, float aHitX, float aHitY, float aHitZ) {
    	if (aSide != mFacing) return F;
		if (isServerSide() && isUseableByPlayerGUI(aPlayer)) openGUI(aPlayer);
		return T;
	}
    
    @Override
	public boolean onPlaced(ItemStack aStack, EntityPlayer aPlayer, MultiTileEntityContainer aMTEContainer, World aWorld, int aX, int aY, int aZ, byte aSide, float aHitX, float aHitY, float aHitZ) {
		super.onPlaced(aStack, aPlayer, aMTEContainer, aWorld, aX, aY, aZ, aSide, aHitX, aHitY, aHitZ);
    	aWorld.playSoundEffect(aX+0.5, aY+0.5, aZ+0.5, Blocks.anvil.stepSound.func_150496_b(), (Blocks.anvil.stepSound.getVolume()+1)/2, Blocks.anvil.stepSound.getPitch()*0.8F);
		return F;
    }
	
	@Override public boolean allowCovers(byte aSide) {return aSide != mFacing;}
	
	// Inventory Stuff
	@Override public boolean canDrop(int aInventorySlot) {return T;}
	@Override public int getInventoryStackLimit() {return 64;}
	@Override public int[] getAccessibleSlotsFromSide(int aSide) {return ZL_INTEGER;}
	@Override public boolean canInsertItem(int aSlot, ItemStack aStack, int aSide) {return F;}
	@Override public boolean canExtractItem(int aSlot, ItemStack aStack, int aSide) {return F;}
	@Override public float getPlayerRelativeBlockHardness(EntityPlayer aPlayer, float aOriginal) {return allowInteraction(aPlayer) ? aOriginal : 0.0F;}
	
	@Override public Object getGUIClient2(int aGUIID, EntityPlayer aPlayer) {return new MultiTileEntityGUIClientSafe(aPlayer.inventory, this);}
	@Override public Object getGUIServer2(int aGUIID, EntityPlayer aPlayer) {return new MultiTileEntityGUICommonSafe(aPlayer.inventory, this);}
	
	public class MultiTileEntityGUICommonSafe extends ContainerCommon {
	    public MultiTileEntityGUICommonSafe(InventoryPlayer aInventoryPlayer, MultiTileEntitySafe aTileEntity) {
	    	super(aInventoryPlayer, aTileEntity);
	    }
	    
		@Override
	    public int addSlots(InventoryPlayer aInventoryPlayer) {
			int tSize = mTileEntity.getSizeInventoryGUI();
			switch(tSize) {
			case  1:
				addSlotToContainer(new Slot_Normal(mTileEntity, 0, 80, 35));
				break;
			case  4:
				addSlotToContainer(new Slot_Normal(mTileEntity, 0, 71, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 1, 89, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 2, 71, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity, 3, 89, 44));
				break;
			case  5:
				addSlotToContainer(new Slot_Normal(mTileEntity, 1, 44, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 2, 62, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 3, 80, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 4, 98, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 5,116, 35));
				break;
			case  8:
				addSlotToContainer(new Slot_Normal(mTileEntity, 0, 53, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 1, 71, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 2, 89, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 3,107, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 4, 53, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity, 5, 71, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity, 6, 89, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity, 7,107, 44));
				break;
			case  9:
				addSlotToContainer(new Slot_Normal(mTileEntity, 0, 62, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 1, 80, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 2, 98, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 3, 62, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 4, 80, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 5, 98, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 6, 62, 53));
				addSlotToContainer(new Slot_Normal(mTileEntity, 7, 80, 53));
				addSlotToContainer(new Slot_Normal(mTileEntity, 8, 98, 53));
				break;
			case 15:
				addSlotToContainer(new Slot_Normal(mTileEntity, 0, 44, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 1, 62, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 2, 80, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 3, 98, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 4,116, 17));
				addSlotToContainer(new Slot_Normal(mTileEntity, 5, 44, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 6, 62, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 7, 80, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 8, 98, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity, 9,116, 35));
				addSlotToContainer(new Slot_Normal(mTileEntity,10, 44, 53));
				addSlotToContainer(new Slot_Normal(mTileEntity,11, 62, 53));
				addSlotToContainer(new Slot_Normal(mTileEntity,12, 80, 53));
				addSlotToContainer(new Slot_Normal(mTileEntity,13, 98, 53));
				addSlotToContainer(new Slot_Normal(mTileEntity,14,116, 53));
				break;
			case 16:
				addSlotToContainer(new Slot_Normal(mTileEntity, 0, 53,  8));
				addSlotToContainer(new Slot_Normal(mTileEntity, 1, 71,  8));
				addSlotToContainer(new Slot_Normal(mTileEntity, 2, 89,  8));
				addSlotToContainer(new Slot_Normal(mTileEntity, 3,107,  8));
				addSlotToContainer(new Slot_Normal(mTileEntity, 4, 53, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 5, 71, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 6, 89, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 7,107, 26));
				addSlotToContainer(new Slot_Normal(mTileEntity, 8, 53, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity, 9, 71, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity,10, 89, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity,11,107, 44));
				addSlotToContainer(new Slot_Normal(mTileEntity,12, 53, 62));
				addSlotToContainer(new Slot_Normal(mTileEntity,13, 71, 62));
				addSlotToContainer(new Slot_Normal(mTileEntity,14, 89, 62));
				addSlotToContainer(new Slot_Normal(mTileEntity,15,107, 62));
				break;
			}
			return super.addSlots(aInventoryPlayer);
	    }
		
		@Override public int getSlotCount() {return mTileEntity.getSizeInventoryGUI();}
		@Override public int getShiftClickSlotCount() {return mTileEntity.getSizeInventoryGUI();}
	}
	
	@SideOnly(Side.CLIENT)
	public class MultiTileEntityGUIClientSafe extends ContainerClient {
	    public MultiTileEntityGUIClientSafe(InventoryPlayer aInventoryPlayer, MultiTileEntitySafe aTileEntity) {
	    	super(new MultiTileEntityGUICommonSafe(aInventoryPlayer, aTileEntity), RES_PATH_GUI + "chests/" + aTileEntity.getSizeInventoryGUI() + ".png");
	    }
	    
	    @Override
		protected void drawGuiContainerForegroundLayer(int p_146979_1_, int p_146979_2_) {
	    	fontRendererObj.drawString(mContainer.mTileEntity.getInventoryNameGUI(), 8,  4, 4210752);
		}
	}
}